#
# sgksx3.rb
#
# $Id: sgksx3.rb,v 1.1 2000/11/21 03:02:07 keiko Exp $
#

require "narray"
require "numru/dcl"

include NumRu::DCL
include Math


NP = 100
ux = NArray.sfloat(NP)
uy = NArray.sfloat(NP)

#-- data ---
ux.indgen(1.0, 1.0)
for i in 1..NP
  uy[i-1]=exp(-i*0.03)*sin(i*3.14/180*20)
end

#-- graph ---
iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; sgpwsn; gets)).to_i
iws = iws.abs
sgopn iws

slrat(2.0, 1.0)
sldiv('Y', 2, 1)
slmgn(0.1, 0.1, 0.1, 0.1)

#     TEST POLYLINE, POLYMARKER, TEXT PRIMITIVE IN WC.
#     TEST POLYLINE, POLYMARKER, TEXT PRIMITIVE IN NDC.
#     TRANSFORMATION FUNCTION : LINEAR*LINEAR
sgfrm
sgswnd(1.0, NP.to_f, -1.0, +1.0)
sgsvpt(0.1, 0.9, 0.1, 0.9)
sgstrn(1)
sgstrf

slpwwr(1)

sglnzu(1.0, 0.0, NP.to_f, 0.0, 1)
sglnzu(1.0, -1.0, 1.0, +1.0, 1)

sgplzu(NP, ux, uy, 2, 3)
sgpmzu(NP, ux, uy, 5, 3, 0.02)
sgtxzv(0.5, 0.9, 'TEST1', 0.05, 0, 0, 3)

#     TEST POLYLINE, POLYMARKER, TEXT PRIMITIVE IN WC.
#     TEST POLYLINE, POLYMARKER, TEXT PRIMITIVE IN NDC.
#     TRANSFORMATION FUNCTION : LOG*LINEAR
sgfrm
sgswnd(1.0, NP.to_f, -1.0, +1.0)
sgsvpt(0.1, 0.9, 0.1, 0.9)
sgstrn(3)
sgstrf

slpwwr(1)

gllset('LMISS', true)
sgiset('NPMSKIP', 2)
ux[ 4]=999.0
uy[19]=999.0

sglnzu(1.0, 0.0, NP.to_f, 0.0, 1)
sglnzu(1.0, -1.0, 1.0, +1.0, 1)

sgplzu(NP, ux, uy, 3, 3)
sgpmzu(NP, ux, uy, 2, 3, 0.02)
sgtxzv(0.5, 0.9, 'TEST2', 0.05, 0, 0, 3)

sgcls

